# BracketingNonlinearSolve.jl

Fast implementations of interval root finding algorithms in Julia that satisfy the SciML
common interface. BracketingNonlinearSolve.jl focuses on low-dependency implementations of
very fast methods for very small and simple problems. For the full set of solvers, see
[NonlinearSolve.jl](https://github.com/SciML/NonlinearSolve.jl), of which
BracketingNonlinearSolve.jl is just one solver set.

For information on using the package,
[see the stable documentation](https://docs.sciml.ai/NonlinearSolve/stable/). Use the
[in-development documentation](https://docs.sciml.ai/NonlinearSolve/dev/) for the version of
the documentation which contains the unreleased features.

## High Level Examples

```julia
using BracketingNonlinearSolve

f(u, p) = u .* u .- 2.0
u0 = (1.0, 2.0) # brackets
probB = IntervalNonlinearProblem(f, u0)
sol = solve(probB, ITP())
```

module BracketingNonlinearSolveChainRulesCoreExt

using BracketingNonlinearSolve: bracketingnonlinear_solve_up, CommonSolve, SciMLBase
using CommonSolve: solve
using SciMLBase: IntervalNonlinearProblem, unwrapped_f
using ForwardDiff: derivative, gradient
using ChainRulesCore: ChainRulesCore, AbstractThunk, NoTangent, Tangent, unthunk

function ChainRulesCore.rrule(
        ::typeof(bracketingnonlinear_solve_up),
        prob::IntervalNonlinearProblem,
        sensealg, p, alg, args...; kwargs...
    )
    out = solve(prob, alg)
    u = out.u
    f = unwrapped_f(prob.f)
    function ∇bracketingnonlinear_solve_up(Δ)
        Δ = Δ isa AbstractThunk ? unthunk(Δ) : Δ
        # Δ = dg/du
        Δ isa Tangent ? delu = Δ.u : delu = Δ
        λ = only(derivative(u -> f(u, p), only(u)) \ delu)
        if p isa Number
            dgdp = -λ * derivative(p -> f(u, p), p)
        else
            dgdp = -λ * gradient(p -> f(u, p), p)
        end
        return (
            NoTangent(), NoTangent(), NoTangent(),
            dgdp, NoTangent(),
            ntuple(_ -> NoTangent(), length(args))...,
        )
    end
    return out, ∇bracketingnonlinear_solve_up
end

end

module Impl

prevfloat_tdir(x, x0, x1) = ifelse(x1 > x0, prevfloat(x), nextfloat(x))
nextfloat_tdir(x, x0, x1) = ifelse(x1 > x0, nextfloat(x), prevfloat(x))
max_tdir(a, b, x0, x1) = ifelse(x1 > x0, max(a, b), min(a, b))

function bracket(f::F, a, b, c) where {F}
    if iszero(f(c))
        ā, b̄, d = a, b, c
    else
        if f(a) * f(c) < 0
            ā, b̄, d = a, c, b
        elseif f(b) * f(c) < 0
            ā, b̄, d = c, b, a
        end
    end
    return ā, b̄, d
end

function newton_quadratic(f::F, a, b, d, k) where {F}
    A = ((f(d) - f(b)) / (d - b) - (f(b) - f(a)) / (b - a)) / (d - a)
    B = (f(b) - f(a)) / (b - a)

    if iszero(A)
        return a - (1 / B) * f(a)
    elseif A * f(a) > 0
        rᵢ₋₁ = a
    else
        rᵢ₋₁ = b
    end

    for _ in 1:k
        rᵢ = rᵢ₋₁ -
            (f(a) + B * (rᵢ₋₁ - a) + A * (rᵢ₋₁ - a) * (rᵢ₋₁ - b)) /
            (B + A * (2 * rᵢ₋₁ - a - b))
        rᵢ₋₁ = rᵢ
    end

    return rᵢ₋₁
end

function ipzero(f::F, a, b, c, d) where {F}
    Q₁₁ = (c - d) * f(c) / (f(d) - f(c))
    Q₂₁ = (b - c) * f(b) / (f(c) - f(b))
    Q₃₁ = (a - b) * f(a) / (f(b) - f(a))
    D₂₁ = (b - c) * f(c) / (f(c) - f(b))
    D₃₁ = (a - b) * f(b) / (f(b) - f(a))
    Q₂₂ = (D₂₁ - Q₁₁) * f(b) / (f(d) - f(b))
    Q₃₂ = (D₃₁ - Q₂₁) * f(a) / (f(c) - f(a))
    D₃₂ = (D₃₁ - Q₂₁) * f(c) / (f(c) - f(a))
    Q₃₃ = (D₃₂ - Q₂₂) * f(a) / (f(d) - f(a))

    return a + Q₃₁ + Q₃₂ + Q₃₃
end

end

"""
    Bisection(; exact_left = false, exact_right = false)

A common bisection method.

### Keyword Arguments

  - `exact_left`: whether to enforce whether the left side of the interval must be exactly
    zero for the returned result. Defaults to false.
  - `exact_right`: whether to enforce whether the right side of the interval must be exactly
    zero for the returned result. Defaults to false.

!!! danger "Keyword Arguments"

    Currently, the keyword arguments are not implemented.
"""
@kwdef struct Bisection <: AbstractBracketingAlgorithm
    exact_left::Bool = false
    exact_right::Bool = false
end

function SciMLBase.__solve(
        prob::IntervalNonlinearProblem, alg::Bisection, args...;
        maxiters = 1000, abstol = nothing, verbose::NonlinearVerbosity = NonlinearVerbosity(), kwargs...
    )
    @assert !SciMLBase.isinplace(prob) "`Bisection` only supports out-of-place problems."

    f = Base.Fix2(prob.f, prob.p)
    left, right = prob.tspan
    fl, fr = f(left), f(right)

    abstol = NonlinearSolveBase.get_tolerance(
        left, abstol, promote_type(eltype(left), eltype(right))
    )

    if iszero(fl)
        return build_exact_solution(prob, alg, left, fl, ReturnCode.ExactSolutionLeft)
    end

    if iszero(fr)
        return build_exact_solution(prob, alg, right, fr, ReturnCode.ExactSolutionRight)
    end

    if sign(fl) == sign(fr)
        @SciMLMessage(
            "The interval is not an enclosing interval, opposite signs at the \
        boundaries are required.",
            verbose, :non_enclosing_interval
        )
        return build_bracketing_solution(prob, alg, left, fl, left, right, ReturnCode.InitialFailure)
    end

    return internal_bisection(f, left, right, fl, fr, abstol, maxiters, prob, alg)
end

# Bisection main loop is implemented in separate function so that it can be reused
# as a fallback solver in other solvers
function internal_bisection(f::F, left, right, fl, fr, abstol, maxiters, prob, alg) where {F}
    i = 1
    while i ≤ maxiters
        mid = (left + right) / 2

        if mid == left || mid == right
            return build_bracketing_solution(prob, alg, left, fl, left, right, ReturnCode.FloatingPointLimit)
        end

        fm = f(mid)
        if iszero(fm)
            return build_exact_solution(prob, alg, mid, fm, ReturnCode.Success)
        end

        if abs((right - left) / 2) < abstol
            return build_bracketing_solution(prob, alg, mid, fm, left, right, ReturnCode.Success)
        end

        if sign(fl) == sign(fm)
            fl = fm
            left = mid
        else
            fr = fm
            right = mid
        end

        i += 1
    end

    return build_bracketing_solution(prob, alg, left, fl, left, right, ReturnCode.MaxIters)
end

@testsnippet RootfindingTestSnippet begin
    linear_f(u, p) = u .- p
    quadratic_f(u, p) = u .* u .- p
    quadratic_f!(du, u, p) = (du .= u .* u .- p)
    quadratic_f2(u, p) = @. p[1] * u * u - p[2]
end

@testitem "Interval Nonlinear Problems" setup = [RootfindingTestSnippet] tags = [:core] begin
    using ForwardDiff

    @testset for alg in (
            Alefeld(), Bisection(), Brent(), Falsi(), ITP(), Muller(), Ridder(), ModAB(), nothing,
        )
        tspan = (1.0, 20.0)

        function g(p)
            probN = IntervalNonlinearProblem{false}(quadratic_f, typeof(p).(tspan), p)
            return solve(probN, alg; abstol = 1.0e-9).left
        end

        @testset for p in 1.1:0.1:100.0
            @test g(p) ≈ sqrt(p) atol = 1.0e-3 rtol = 1.0e-3
            @test ForwardDiff.derivative(g, p) ≈ 1 / (2 * sqrt(p)) atol = 1.0e-3 rtol = 1.0e-3
        end

        t = (p) -> [sqrt(p[2] / p[1])]
        p = [0.9, 50.0]

        function g2(p)
            probN = IntervalNonlinearProblem{false}(quadratic_f2, tspan, p)
            sol = solve(probN, alg; abstol = 1.0e-9)
            return [sol.u]
        end

        @test g2(p) ≈ [sqrt(p[2] / p[1])] atol = 1.0e-3 rtol = 1.0e-3
        @test ForwardDiff.jacobian(g2, p) ≈ ForwardDiff.jacobian(t, p) atol = 1.0e-3 rtol = 1.0e-3

        probB = IntervalNonlinearProblem{false}(quadratic_f, (1.0, 2.0), 2.0)
        sol = solve(probB, alg; abstol = 1.0e-9)
        @test sol.left ≈ sqrt(2.0) atol = 1.0e-3 rtol = 1.0e-3

        if !(alg isa Bisection || alg isa Falsi)
            probB = IntervalNonlinearProblem{false}(quadratic_f, (sqrt(2.0), 10.0), 2.0)
            sol = solve(probB, alg; abstol = 1.0e-9)
            @test sol.left ≈ sqrt(2.0) atol = 1.0e-3 rtol = 1.0e-3

            probB = IntervalNonlinearProblem{false}(quadratic_f, (0.0, sqrt(2.0)), 2.0)
            sol = solve(probB, alg; abstol = 1.0e-9)
            @test sol.left ≈ sqrt(2.0) atol = 1.0e-3 rtol = 1.0e-3
        end
    end
end

@testitem "Tolerance Tests Interval Methods" setup = [RootfindingTestSnippet] tags = [:core] begin
    prob = IntervalNonlinearProblem(quadratic_f, (1.0, 20.0), 2.0)
    ϵ = eps(Float64) # least possible tol for all methods

    @testset for alg in (Bisection(), Falsi(), ITP(), Muller())
        @testset for abstol in [0.1, 0.01, 0.001, 0.0001, 1.0e-5, 1.0e-6]
            sol = solve(prob, alg; abstol)
            result_tol = abs(sol.u - sqrt(2))
            @test result_tol < abstol
            # test that the solution is not calculated upto max precision
            @test result_tol > ϵ
        end
    end

    @testset for alg in (Brent(), Ridder(), ModAB(), nothing)
        # These solvers converge rapidly so as we lower tolerance below 0.01, it
        # converges with max precision to the solution
        @testset for abstol in [0.1]
            sol = solve(prob, alg; abstol)
            result_tol = abs(sol.u - sqrt(2))
            @test result_tol < abstol
            # test that the solution is not calculated upto max precision
            @test result_tol > ϵ
        end
    end
end

@testitem "Zero-Tolerance Tests Interval Methods" setup = [RootfindingTestSnippet] tags = [:core] begin
    prob = IntervalNonlinearProblem(quadratic_f, (1.0, 20.0), 2.0)
    prob_lin = IntervalNonlinearProblem(linear_f, (-1.0, 1.0), 0.0)

    @testset for alg in (Alefeld(), Bisection(), Brent(), ITP(), Ridder(), ModAB(), nothing)
        sol = solve(prob, alg; abstol = 0.0)
        # Test that solution is to floating point precision
        @test sol.retcode == ReturnCode.FloatingPointLimit
        @test quadratic_f(sol.left, 2.0) < 0
        @test quadratic_f(sol.right, 2.0) > 0
        @test nextfloat(sol.left) == sol.right

        # Solve problem with a root representable with floating point
        sol = solve(prob_lin, alg; abstol = 0.0)
        # Test that solution is exact
        @test sol.retcode == ReturnCode.Success
        @test sol.u == 0.0
        @test sol.left == 0.0
        @test sol.right == 0.0
    end
end

@testitem "ForwardDiff with Duals in tspan" tags = [:core] begin
    using ForwardDiff: ForwardDiff, Dual, Partials, Tag, partials

    # Mixed case: tspan has Duals AND f's closure captures Dual-valued state.
    # The derivative w.r.t. the boundary point is zero, but dt*/dθ is nonzero
    # via the implicit function theorem: dt*/dθ = -(∂f/∂θ)/(∂f/∂t).
    # Uses a proper ForwardDiff Tag (not Nothing) so nested Dual ordering works.
    struct TestMixedTag end
    @testset "mixed: closure captures Duals" for alg in (
            Alefeld(), Bisection(), Brent(), Falsi(), ITP(), Ridder(), ModAB(), nothing,
        )
        @testset for p_val in [0.5, 1.0, 2.0, 3.0, 4.0, 5.0]
            TTag = typeof(Tag(TestMixedTag(), Float64))
            p = Dual{TTag}(p_val, Partials((1.0,)))
            exact_root = sqrt(2 / p_val)
            exact_deriv = -sqrt(2) / (2 * p_val^(3 / 2))

            cond(t, _ = nothing) = 1 - p / 2 * t^2

            t_left = Dual{TTag}(0.0, Partials((0.0,)))
            t_right = Dual{TTag}(exact_root + 0.5, Partials((0.0,)))

            prob = IntervalNonlinearProblem{false}(cond, (t_left, t_right))
            sol = solve(prob, alg; abstol = 0.0, reltol = 0.0)

            @test ForwardDiff.value(sol.u) ≈ exact_root atol = 1.0e-10
            @test partials(sol.u, 1) ≈ exact_deriv rtol = 1.0e-3
            @test all(isfinite, [partials(sol.left, 1), partials(sol.right, 1)])
        end
    end

    # Pure tspan-Dual case: f returns plain floats, derivative w.r.t. boundary is zero.
    struct TestPureTag end
    @testset "pure: f returns Float64" for alg in (
            Alefeld(), Bisection(), Brent(), Falsi(), ITP(), Ridder(), ModAB(), nothing,
        )
        f_plain(t, _ = nothing) = t^2 - 2.0

        TTag = typeof(Tag(TestPureTag(), Float64))
        t_left = Dual{TTag}(0.0, Partials((1.0,)))
        t_right = Dual{TTag}(3.0, Partials((1.0,)))

        prob = IntervalNonlinearProblem{false}(f_plain, (t_left, t_right))
        sol = solve(prob, alg; abstol = 0.0, reltol = 0.0)

        @test ForwardDiff.value(sol.u) ≈ sqrt(2.0) atol = 1.0e-10
        @test partials(sol.u, 1) == 0.0
        @test partials(sol.left, 1) == 0.0
        @test partials(sol.right, 1) == 0.0
    end
end

@testitem "ModAB non-shrinking iteration" tags = [:core] begin
    # Issue #860
    a, b, c = 0.28299683548569865, 0.23110561490429102, -0.04293615418571393
    f = (x, _) -> a * x^2 + b * x + c
    tspan = (-18.26561304888476, -0.8216404439033063)

    prob = IntervalNonlinearProblem{false}(f, tspan)
    sol = solve(prob, ModAB(); abstol = 0.0, reltol = 0.0)

    @test sol.retcode == ReturnCode.FloatingPointLimit
    @test sol.left == -0.9726263117443217
    @test sol.right == -0.9726263117443216
end

@testitem "Flipped Signs and Reversed Tspan" setup = [RootfindingTestSnippet] tags = [:core] begin
    @testset for alg in (
            Alefeld(), Bisection(), Brent(), Falsi(), ITP(), Muller(), Ridder(), ModAB(), nothing,
        )
        f1(u, p) = u * u - p
        f2(u, p) = p - u * u

        for p in 1:4
            sol1 = solve(IntervalNonlinearProblem(f1, (1.0, 2.0), p), alg)
            sol2 = solve(IntervalNonlinearProblem(f2, (1.0, 2.0), p), alg)
            sol3 = solve(IntervalNonlinearProblem(f1, (2.0, 1.0), p), alg)
            sol4 = solve(IntervalNonlinearProblem(f2, (2.0, 1.0), p), alg)
            @test abs.(sol1.u) ≈ sqrt.(p)
            @test abs.(sol2.u) ≈ sqrt.(p)
            @test abs.(sol3.u) ≈ sqrt.(p)
            @test abs.(sol4.u) ≈ sqrt.(p)
            # Test brackets consistency
            @test sol1.left ≤ sol1.right
            @test sol2.left ≤ sol2.right
            @test sol3.left ≥ sol3.right
            @test sol4.left ≥ sol4.right
        end
    end
end

"""
    Brent()

Left non-allocating Brent method.
"""
struct Brent <: AbstractBracketingAlgorithm end

function SciMLBase.__solve(
        prob::IntervalNonlinearProblem, alg::Brent, args...;
        maxiters = 1000, abstol = nothing, verbose = NonlinearVerbosity(), kwargs...
    )
    @assert !SciMLBase.isinplace(prob) "`Brent` only supports out-of-place problems."

    if verbose isa Bool
        if verbose
            verbose = NonlinearVerbosity()
        else
            verbose = NonlinearVerbosity(None())
        end
    elseif verbose isa AbstractVerbosityPreset
        verbose = NonlinearVerbosity(verbose)
    end

    f = Base.Fix2(prob.f, prob.p)
    left, right = prob.tspan
    fl, fr = f(left), f(right)
    ϵ = eps(convert(typeof(fl), 1))

    abstol = NonlinearSolveBase.get_tolerance(
        left, abstol, promote_type(eltype(left), eltype(right))
    )

    if iszero(fl)
        return build_exact_solution(prob, alg, left, fl, ReturnCode.ExactSolutionLeft)
    end

    if iszero(fr)
        return build_exact_solution(prob, alg, right, fr, ReturnCode.ExactSolutionRight)
    end

    if sign(fl) == sign(fr)
        @SciMLMessage(
            "The interval is not an enclosing interval, opposite signs at the \
        boundaries are required.",
            verbose, :non_enclosing_interval
        )
        return build_bracketing_solution(prob, alg, left, fl, left, right, ReturnCode.InitialFailure)
    end

    if abs(fl) < abs(fr)
        left, right = right, left
        fl, fr = fr, fl
    end

    c = left
    d = c
    i = 1
    cond = true

    while i < maxiters
        fc = f(c)

        if fl != fc && fr != fc
            # Inverse quadratic interpolation
            s = left * fr * fc / ((fl - fr) * (fl - fc)) +
                right * fl * fc / ((fr - fl) * (fr - fc)) +
                c * fl * fr / ((fc - fl) * (fc - fr))
        else
            # Secant method
            s = right - fr * (right - left) / (fr - fl)
        end

        if (
                s < min((3 * left + right) / 4, right) ||
                    s > max((3 * left + right) / 4, right)
            ) ||
                (cond && abs(s - right) ≥ abs(right - c) / 2) ||
                (!cond && abs(s - right) ≥ abs(c - d) / 2) ||
                (cond && abs(right - c) ≤ ϵ) ||
                (!cond && abs(c - d) ≤ ϵ)
            # Bisection method
            s = (left + right) / 2
            if s == left || s == right
                return build_bracketing_solution(prob, alg, left, fl, left, right, ReturnCode.FloatingPointLimit)
            end
            cond = true
        else
            cond = false
        end

        fs = f(s)
        if iszero(fs)
            return build_exact_solution(prob, alg, s, fs, ReturnCode.Success)
        end

        if abs((right - left) / 2) < abstol
            return build_bracketing_solution(prob, alg, s, fs, left, right, ReturnCode.Success)
        end

        if fl * fs < 0
            d, c, right = c, right, s
            fr = fs
        else
            left = s
            fl = fs
        end

        if abs(fl) < abs(fr)
            d = c
            c, right = right, left
            left = c
            fc, fr = fr, fl
            fl = fc
        end
        i += 1
    end

    return build_bracketing_solution(prob, alg, left, fl, left, right, ReturnCode.MaxIters)
end

@testitem "Aqua" tags = [:core] begin
    using Aqua, BracketingNonlinearSolve

    Aqua.test_all(
        BracketingNonlinearSolve;
        piracies = false, ambiguities = false, stale_deps = false, deps_compat = false
    )
    Aqua.test_stale_deps(BracketingNonlinearSolve; ignore = [:SciMLJacobianOperators])
    Aqua.test_deps_compat(BracketingNonlinearSolve; ignore = [:SciMLJacobianOperators])
    Aqua.test_piracies(BracketingNonlinearSolve; treat_as_own = [IntervalNonlinearProblem])
    Aqua.test_ambiguities(BracketingNonlinearSolve; recursive = false)
end

@testitem "Explicit Imports" tags = [:core] begin
    import ForwardDiff
    using ExplicitImports, BracketingNonlinearSolve

    @test check_no_implicit_imports(BracketingNonlinearSolve; skip = (Base, Core)) ===
        nothing
    @test check_no_stale_explicit_imports(BracketingNonlinearSolve) === nothing
    @test check_all_qualified_accesses_via_owners(BracketingNonlinearSolve) === nothing
end

"""
    Falsi()

A non-allocating regula falsi method.
"""
struct Falsi <: AbstractBracketingAlgorithm end

function SciMLBase.__solve(
        prob::IntervalNonlinearProblem, alg::Falsi, args...;
        maxiters = 1000, abstol = nothing, verbose = NonlinearVerbosity(), kwargs...
    )
    @assert !SciMLBase.isinplace(prob) "`False` only supports out-of-place problems."

    if verbose isa Bool
        if verbose
            verbose = NonlinearVerbosity()
        else
            verbose = NonlinearVerbosity(None())
        end
    elseif verbose isa AbstractVerbosityPreset
        verbose = NonlinearVerbosity(verbose)
    end

    f = Base.Fix2(prob.f, prob.p)
    l, r = prob.tspan # don't reuse these variables
    left, right = prob.tspan
    fl, fr = f(left), f(right)

    abstol = NonlinearSolveBase.get_tolerance(
        left, abstol, promote_type(eltype(left), eltype(right))
    )

    if iszero(fl)
        return build_exact_solution(prob, alg, left, fl, ReturnCode.ExactSolutionLeft)
    end

    if iszero(fr)
        return build_exact_solution(prob, alg, right, fr, ReturnCode.ExactSolutionRight)
    end

    if sign(fl) == sign(fr)
        @SciMLMessage(
            "The interval is not an enclosing interval, opposite signs at the \
        boundaries are required.",
            verbose, :non_enclosing_interval
        )
        return build_bracketing_solution(prob, alg, left, fl, left, right, ReturnCode.InitialFailure)
    end

    i = 1
    while i ≤ maxiters
        if Impl.nextfloat_tdir(left, l, r) == right
            return build_bracketing_solution(prob, alg, left, fl, left, right, ReturnCode.FloatingPointLimit)
        end

        mid = (fr * left - fl * right) / (fr - fl)
        for _ in 1:10
            mid = Impl.max_tdir(left, Impl.prevfloat_tdir(mid, l, r), l, r)
        end

        (mid == left || mid == right) && break

        fm = f(mid)
        if iszero(fm)
            return build_exact_solution(prob, alg, mid, fm, ReturnCode.Success)
        end

        if abs((right - left) / 2) < abstol
            return build_bracketing_solution(prob, alg, mid, fm, left, right, ReturnCode.Success)
        end

        if abs(fm) < abstol
            right = mid
            break
        end

        if sign(fl) == sign(fm)
            fl, left = fm, mid
        else
            fr, right = fm, mid
        end

        i += 1
    end

    # Fallback to bisection solver
    return internal_bisection(f, left, right, fl, fr, abstol, maxiters - i, prob, alg)
end

"""
    ITP(; k1::Real = 0.007, k2::Real = 1.5, n0::Int = 10)

ITP (Interpolate Truncate & Project)

Use the [ITP method](https://en.wikipedia.org/wiki/ITP_method) to find a root of a bracketed
function, with a convergence rate between 1 and 1.62.

This method was introduced in the paper "An Enhancement of the Bisection Method Average
Performance Preserving Minmax Optimality" (https://doi.org/10.1145/3423597) by
I. F. D. Oliveira and R. H. C. Takahashi.

### Tuning Parameters

The following keyword parameters are accepted.

  - `n₀::Int = 10`, the 'slack'. Must not be negative. When n₀ = 0 the worst-case is
    identical to that of bisection, but increasing n₀ provides greater opportunity for
    superlinearity.
  - `scaled_κ₁::Float64 = 0.2`. Must not be negative. The recommended value is `0.2`.
    Lower values produce tighter asymptotic behaviour, while higher values improve the
    steady-state behaviour when truncation is not helpful.
  - `κ₂::Real = 2`. Must lie in [1, 1+ϕ ≈ 2.62). Higher values allow for a greater
    convergence rate, but also make the method more succeptable to worst-case performance.
    In practice, κ₂=1, 2 seems to work well due to the computational simplicity, as κ₂ is
    used as an exponent in the method.

### Computation of κ₁

In the current implementation, we compute κ₁ = scaled_κ₁·|Δx₀|^(1 - κ₂); this allows κ₁ to
adapt to the length of the interval and keep the proposed steps proportional to Δx.

### Worst Case Performance

n½ + `n₀` iterations, where n½ is the number of iterations using bisection
(n½ = ⌈log2(Δx)/2`tol`⌉).

### Asymptotic Performance

If `f` is twice differentiable and the root is simple, then with `n₀` > 0 the convergence
rate is √`κ₂`.
"""
@concrete struct ITP <: AbstractBracketingAlgorithm
    scaled_k1
    k2
    n0::Int
end

function ITP(; scaled_k1::Real = 0.2, k2::Real = 2, n0::Int = 10)
    scaled_k1 < 0 && error("Hyper-parameter κ₁ should not be negative")
    n0 < 0 && error("Hyper-parameter n₀ should not be negative")
    if !(1 <= k2 <= 1.5 + sqrt(5) / 2)
        throw(ArgumentError("Hyper-parameter κ₂ should be between 1 and 1 + ϕ where \
                             ϕ ≈ 1.618... is the golden ratio"))
    end
    return ITP(scaled_k1, k2, n0)
end

function SciMLBase.__solve(
        prob::IntervalNonlinearProblem, alg::ITP, args...;
        maxiters = 1000, abstol = nothing, verbose::NonlinearVerbosity = NonlinearVerbosity(), kwargs...
    )
    @assert !SciMLBase.isinplace(prob) "`ITP` only supports out-of-place problems."

    f = Base.Fix2(prob.f, prob.p)
    left, right = minmax(promote(prob.tspan...)...)
    fl, fr = f(left), f(right)

    abstol = NonlinearSolveBase.get_tolerance(
        left, abstol, promote_type(eltype(left), eltype(right))
    )

    if iszero(fl)
        return build_exact_solution(prob, alg, left, fl, ReturnCode.ExactSolutionLeft)
    end

    if iszero(fr)
        return build_exact_solution(prob, alg, right, fr, ReturnCode.ExactSolutionRight)
    end

    if sign(fl) == sign(fr)
        @SciMLMessage(
            "The interval is not an enclosing interval, opposite signs at the \
        boundaries are required.",
            verbose, :non_enclosing_interval
        )
        return build_bracketing_solution(prob, alg, left, fl, left, right, ReturnCode.InitialFailure)
    end

    ϵ = abstol
    k2 = alg.k2
    span = right - left
    k1 = alg.scaled_k1 * span^(1 - k2) # k1 > 0
    n0 = alg.n0
    if span / 2 > ϵ * floatmax(typeof(span))
        # Workaround for when span / (2 * ϵ) == Inf
        ϵ_s = span / 2 * exp2(n0)
    else
        n_h = exponent(span / (2 * ϵ))
        ϵ_s = ϵ * exp2(n_h) * exp2(n0)
    end
    T0 = zero(fl)

    i = 1
    while i ≤ maxiters
        span = right - left
        mid = (left + right) / 2
        r = ϵ_s - (span / 2)

        x_f = left + span * (fl / (fl - fr))  # Interpolation Step

        δ = max(k1 * span^k2, eps(x_f))
        diff = mid - x_f

        xt = ifelse(δ ≤ abs(diff), x_f + copysign(δ, diff), mid)  # Truncation Step

        xp = ifelse(abs(xt - mid) ≤ r, xt, mid - copysign(r, diff))  # Projection Step
        if span < 2ϵ
            return build_bracketing_solution(prob, alg, xt, f(xt), left, right, ReturnCode.Success)
        end
        yp = f(xp)
        yps = yp * sign(fr)
        if yps > T0
            right, fr = xp, yp
        elseif yps < T0
            left, fl = xp, yp
        else
            return build_exact_solution(prob, alg, xp, yps, ReturnCode.Success)
        end

        i += 1
        ϵ_s /= 2

        if nextfloat(left) == right
            return build_bracketing_solution(prob, alg, right, fr, left, right, ReturnCode.FloatingPointLimit)
        end
    end

    return build_bracketing_solution(prob, alg, left, fl, left, right, ReturnCode.MaxIters)
end

"""
    Alefeld()

An implementation of algorithm 4.2 from [Alefeld](https://dl.acm.org/doi/10.1145/210089.210111).

The paper brought up two new algorithms. Here choose to implement algorithm 4.2 rather than
algorithm 4.1 because, in certain sense, the second algorithm(4.2) is an optimal procedure.
"""
struct Alefeld <: AbstractBracketingAlgorithm end

function SciMLBase.__solve(
        prob::IntervalNonlinearProblem, alg::Alefeld, args...;
        maxiters = 1000, abstol = nothing, kwargs...
    )
    f = Base.Fix2(prob.f, prob.p)
    a, b = prob.tspan
    c = a - (b - a) / (f(b) - f(a)) * f(a)

    fc = f(c)
    if a == c || b == c
        return build_bracketing_solution(prob, alg, c, fc, a, b, ReturnCode.FloatingPointLimit)
    end

    if iszero(fc)
        return build_exact_solution(prob, alg, c, fc, ReturnCode.Success)
    end

    a, b, d = Impl.bracket(f, a, b, c)
    e = zero(a)   # Set e as 0 before iteration to avoid a non-value f(e)

    for i in 2:maxiters
        # The first bracketing block
        f₁, f₂, f₃, f₄ = f(a), f(b), f(d), f(e)
        if i == 2 || (f₁ == f₂ || f₁ == f₃ || f₁ == f₄ || f₂ == f₃ || f₂ == f₄ || f₃ == f₄)
            c = Impl.newton_quadratic(f, a, b, d, 2)
        else
            c = Impl.ipzero(f, a, b, d, e)
            if (c - a) * (c - b) ≥ 0
                c = Impl.newton_quadratic(f, a, b, d, 2)
            end
        end

        ē, fc = d, f(c)
        if a == c || b == c
            return build_bracketing_solution(prob, alg, c, fc, a, b, ReturnCode.FloatingPointLimit)
        end

        if iszero(fc)
            return build_exact_solution(prob, alg, c, fc, ReturnCode.Success)
        end

        ā, b̄, d̄ = Impl.bracket(f, a, b, c)

        # The second bracketing block
        f₁, f₂, f₃, f₄ = f(ā), f(b̄), f(d̄), f(ē)
        if f₁ == f₂ || f₁ == f₃ || f₁ == f₄ || f₂ == f₃ || f₂ == f₄ || f₃ == f₄
            c = Impl.newton_quadratic(f, ā, b̄, d̄, 3)
        else
            c = Impl.ipzero(f, ā, b̄, d̄, ē)
            if (c - ā) * (c - b̄) ≥ 0
                c = Impl.newton_quadratic(f, ā, b̄, d̄, 3)
            end
        end
        fc = f(c)

        if ā == c || b̄ == c
            return build_bracketing_solution(prob, alg, c, fc, ā, b̄, ReturnCode.FloatingPointLimit)
        end

        if iszero(fc)
            return build_exact_solution(prob, alg, c, fc, ReturnCode.Success)
        end

        ā, b̄, d̄ = Impl.bracket(f, ā, b̄, c)

        # The third bracketing block
        u = ifelse(abs(f(ā)) < abs(f(b̄)), ā, b̄)
        c = u - 2 * (b̄ - ā) / (f(b̄) - f(ā)) * f(u)
        if (abs(c - u)) > 0.5 * (b̄ - ā)
            c = 0.5 * (ā + b̄)
        end
        fc = f(c)

        if ā == c || b̄ == c
            return build_bracketing_solution(prob, alg, c, fc, ā, b̄, ReturnCode.FloatingPointLimit)
        end

        if iszero(fc)
            return build_exact_solution(prob, alg, c, fc, ReturnCode.Success)
        end

        ā, b̄, d = Impl.bracket(f, ā, b̄, c)

        # The last bracketing block
        if b̄ - ā < 0.5 * (b - a)
            a, b, e = ā, b̄, d̄
        else
            e = d
            c = 0.5 * (ā + b̄)
            fc = f(c)

            if ā == c || b̄ == c
                return build_bracketing_solution(prob, alg, c, fc, ā, b̄, ReturnCode.FloatingPointLimit)
            end
            if iszero(fc)
                return build_exact_solution(prob, alg, c, fc, ReturnCode.Success)
            end
            a, b, d = Impl.bracket(f, ā, b̄, c)
        end
    end

    # Reassign the value a, b, and c
    if b == c
        b = d
    elseif a == c
        a = d
    end
    fc = f(c)

    # Return solution when run out of max iteration
    return build_bracketing_solution(prob, alg, c, fc, a, b, ReturnCode.MaxIters)
end

"""
Builder for exact bracketing problems solution.
"""
function build_exact_solution(prob, alg, u, resid, retcode)
    return SciMLBase.build_solution(
        prob, alg, u, resid; retcode = retcode, left = u, right = u
    )
end

"""
Builder for bracketing problems solution.
Ensure that left/right are in the same order as tspan for consistency.
"""
function build_bracketing_solution(prob, alg, u, resid, bound1, bound2, retcode)
    return if xor(bound1 < bound2, prob.tspan[1] < prob.tspan[2])
        SciMLBase.build_solution(
            prob, alg, u, resid; retcode = retcode, left = bound2, right = bound1
        )
    else
        SciMLBase.build_solution(
            prob, alg, u, resid; retcode = retcode, left = bound1, right = bound2
        )
    end
end

"""
    ModAB()

ModAB (Modified Anderson-Bjork)

Use the [ModAB method](https://iopscience.iop.org/article/10.1088/1757-899X/1276/1/012010/) to find a root of a bracketed
function, with a convergence rate between 1.7 and 1.8.

This method was introduced in the paper "Modified Anderson-Bjork’s method for solving non-linear equations 
in structural mechanics" (https://doi.org/10.1088/1757-899X/1276/1/012010) by
N Ganchovski and A Traykov.
"""
struct ModAB <: AbstractBracketingAlgorithm
end

function SciMLBase.__solve(
        prob::IntervalNonlinearProblem, alg::ModAB, args...;
        maxiters = 1000, abstol = nothing, verbose::NonlinearVerbosity = NonlinearVerbosity(), kwargs...
    )
    @assert !SciMLBase.isinplace(prob) "`ModAB` only supports out-of-place problems."

    f = Base.Fix2(prob.f, prob.p)
    x1, x2 = minmax(promote(prob.tspan...)...)
    y1, y2 = f(x1), f(x2)

    abstol = NonlinearSolveBase.get_tolerance(
        x1, abstol, promote_type(eltype(x1), eltype(x2))
    )

    if iszero(y1)
        return build_exact_solution(prob, alg, x1, y1, ReturnCode.ExactSolutionLeft)
    end

    if iszero(y2)
        return build_exact_solution(prob, alg, x2, y2, ReturnCode.ExactSolutionRight)
    end

    if sign(y1) == sign(y2)
        @SciMLMessage(
            "The interval is not an enclosing interval, opposite signs at the \
        boundaries are required.",
            verbose, :non_enclosing_interval
        )
        return build_bracketing_solution(prob, alg, x1, y1, x1, x2, ReturnCode.InitialFailure)
    end

    bisecting = true
    side = 0 # tracks the side that has moved at the previous iteration
    ϵ = abstol
    i = 1
    threshold = x2 - x1  # Threshold to fall back to bisection if AB fails to shrink the interval enough
    C = 16 # safety factor for threshold corresponding to 4 iterations = 2^4
    while i < maxiters
        local x3, y3
        if bisecting # Bisection method is used
            x3 = (x1 + x2) / 2
            y3 = f(x3) # Function value at midpoint
            ym = (y1 + y2) / 2 # Ordinate of chord at midpoint
            # calculate k on each bisection step with account for local function properties and symmetry
            r = 1 - abs(ym / (y2 - y1)) # Symmetry factor
            k = r * r # Deviation factor
            # Check if the function is close enough to linear
            if abs(ym - y3) < k * (abs(ym) + abs(y3))
                bisecting = false
                threshold = (x2 - x1) * C
            end
        else # Anderson-Bjork method is used
            x3 = (x1 * y2 - y1 * x2) / (y2 - y1)
            x3 = clamp(x3, nextfloat(x1), prevfloat(x2))
            y3 = f(x3)
            threshold /= 2
        end
        if iszero(y3)
            return build_exact_solution(prob, alg, x3, y3, ReturnCode.Success)
        elseif (x2 - x1) < 2ϵ
            return build_bracketing_solution(prob, alg, x3, y3, x1, x2, ReturnCode.Success)
        end
        if sign(y1) == sign(y3)
            if side == 1  # Apply Anderson-Bjork correction on the right side
                m = 1 - y3 / y1
                y2 *= m <= 0 ? inv(2 * one(y1)) : m
            elseif !bisecting
                side = 1
            end
            x1, y1 = x3, y3
        else
            if side == -1  # Apply Anderson-Bjork correction on the left side
                m = 1 - y3 / y2
                y1 *= m <= 0 ? inv(2 * one(y1)) : m
            elseif !bisecting
                side = -1
            end
            x2, y2 = x3, y3
        end
        if nextfloat(x1) == x2
            return build_bracketing_solution(prob, alg, x2, f(x2), x1, x2, ReturnCode.FloatingPointLimit)
        end
        i += 1
        if x2 - x1 > threshold # Ff AB fails to shrink the interval enough
            bisecting = true   # reset to bisection
            side = 0
        end
    end
    return build_bracketing_solution(prob, alg, x1, y1, x1, x2, ReturnCode.MaxIters)
end

"""
    Muller(; middle = nothing)

Muller's method for determining a root of a univariate, scalar function.

The algorithm, described in Sec. 9.5.2 of
[Press et al. (2007)](https://numerical.recipes/book.html), is a generalization
of the secant method, using quadratic interpolation of three points to find the
next estimate for the root. Due to the quadratic interpolation, the method is
well suited for obtaining complex roots.

This method requires three initial guesses `(left, middle, right)` for the
solution. The guesses `(left, right) = tspan` are provided by the
`IntervalNonlinearProblem`, while the `middle` guess may be specified as an
optional keyword argument. In notable contrast to the other
`BracketingNonlinearSolve.jl` solvers, the `Muller` algorithm does not need
`(left, right)` to bracket the root.

### Keyword Arguments

  - `middle`: the initial guess for the middle point. If not provided, the
    midpoint of the interval `(left, right)` is used.
"""
struct Muller{T} <: AbstractBracketingAlgorithm
    middle::T
end

Muller() = Muller(nothing)

function SciMLBase.__solve(
        prob::IntervalNonlinearProblem, alg::Muller, args...;
        abstol = nothing, maxiters = 1000, kwargs...
    )
    @assert !SciMLBase.isinplace(prob) "`Muller` only supports out-of-place problems."
    xᵢ₋₂, xᵢ = prob.tspan
    xᵢ₋₁ = isnothing(alg.middle) ? (xᵢ₋₂ + xᵢ) / 2 : alg.middle
    xᵢ₋₂, xᵢ₋₁, xᵢ = promote(xᵢ₋₂, xᵢ₋₁, xᵢ)
    @assert xᵢ₋₂ ≠ xᵢ₋₁ ≠ xᵢ ≠ xᵢ₋₂
    f = Base.Fix2(prob.f, prob.p)
    fxᵢ₋₂, fxᵢ₋₁, fxᵢ = f(xᵢ₋₂), f(xᵢ₋₁), f(xᵢ)

    xᵢ₊₁, fxᵢ₊₁ = xᵢ₋₂, fxᵢ₋₂

    abstol = abs(
        NonlinearSolveBase.get_tolerance(
            xᵢ₋₂, abstol, promote_type(eltype(xᵢ₋₂), eltype(xᵢ))
        )
    )

    for _ in 1:maxiters
        q = (xᵢ - xᵢ₋₁) / (xᵢ₋₁ - xᵢ₋₂)
        A = q * fxᵢ - q * (1 + q) * fxᵢ₋₁ + q^2 * fxᵢ₋₂
        B = (2 * q + 1) * fxᵢ - (1 + q)^2 * fxᵢ₋₁ + q^2 * fxᵢ₋₂
        C = (1 + q) * fxᵢ

        denom₊ = B + √(B^2 - 4 * A * C)
        denom₋ = B - √(B^2 - 4 * A * C)

        if abs(denom₊) ≥ abs(denom₋)
            xᵢ₊₁ = xᵢ - (xᵢ - xᵢ₋₁) * 2 * C / denom₊
        else
            xᵢ₊₁ = xᵢ - (xᵢ - xᵢ₋₁) * 2 * C / denom₋
        end

        fxᵢ₊₁ = f(xᵢ₊₁)

        # Termination Check
        if abstol ≥ abs(fxᵢ₊₁)
            return SciMLBase.build_solution(
                prob, alg, xᵢ₊₁, fxᵢ₊₁;
                retcode = ReturnCode.Success,
                left = xᵢ₊₁, right = xᵢ₊₁
            )
        end

        xᵢ₋₂, xᵢ₋₁, xᵢ = xᵢ₋₁, xᵢ, xᵢ₊₁
        fxᵢ₋₂, fxᵢ₋₁, fxᵢ = fxᵢ₋₁, fxᵢ, fxᵢ₊₁
    end

    return SciMLBase.build_solution(
        prob, alg, xᵢ₊₁, fxᵢ₊₁;
        retcode = ReturnCode.MaxIters,
        left = xᵢ₊₁, right = xᵢ₊₁
    )
end

@testitem "Simple Adjoint Test" tags = [:adjoint] begin
    using ForwardDiff, Zygote, BracketingNonlinearSolve

    ff(u, p) = u^2 .- p[1]

    function solve_nlprob(p)
        prob = IntervalNonlinearProblem{false}(ff, (1.0, 3.0), p)
        sol = solve(prob, Bisection())
        res = sol isa AbstractArray ? sol : sol.u
        return sum(abs2, res)
    end

    p = [2.0, 2.0]

    ∂p_zygote = only(Zygote.gradient(solve_nlprob, p))
    ∂p_forwarddiff = ForwardDiff.gradient(solve_nlprob, p)
    @test ∂p_zygote ≈ ∂p_forwarddiff
end

module BracketingNonlinearSolveForwardDiffExt

using CommonSolve: CommonSolve
using ForwardDiff: ForwardDiff, Dual, Partials
using NonlinearSolveBase: nonlinearsolve_forwarddiff_solve, nonlinearsolve_dual_solution
using SciMLBase: SciMLBase, IntervalNonlinearProblem

using BracketingNonlinearSolve: Bisection, Brent, Alefeld, Falsi, ITP, Ridder, ModAB

const DualIntervalNonlinearProblem{
    T,
    V,
    P,
} = IntervalNonlinearProblem{
    uType, iip, <:Union{<:Dual{T, V, P}, <:AbstractArray{<:Dual{T, V, P}}},
} where {uType, iip}

for algT in (Bisection, Brent, Alefeld, Falsi, ITP, Ridder, ModAB)
    @eval function CommonSolve.solve(
            prob::DualIntervalNonlinearProblem{T, V, P}, alg::$(algT), args...;
            kwargs...
        ) where {T, V, P}
        sol, partials = nonlinearsolve_forwarddiff_solve(prob, alg, args...; kwargs...)
        dual_soln = nonlinearsolve_dual_solution(sol.u, partials, prob.p)
        return SciMLBase.build_solution(
            prob, alg, dual_soln, sol.resid;
            sol.retcode, sol.stats, sol.original,
            left = Dual{T, V, P}(sol.left, partials),
            right = Dual{T, V, P}(sol.right, partials)
        )
    end
end

# Handle the case where Duals are in both tspan AND p. This disambiguates the two
# methods below when both type aliases match. We forward to the p-Dual path since
# nonlinearsolve_forwarddiff_solve handles stripping Duals from both p and tspan.
const DualBothIntervalNonlinearProblem{
    T,
    V,
    P,
} = IntervalNonlinearProblem{
    iip, <:Tuple{Dual{T, V, P}, Dual{T, V, P}},
    <:Union{<:Dual{T, V, P}, <:AbstractArray{<:Dual{T, V, P}}},
} where {iip}

for algT in (Bisection, Brent, Alefeld, Falsi, ITP, Ridder, ModAB)
    @eval function CommonSolve.solve(
            prob::DualBothIntervalNonlinearProblem{T, V, P}, alg::$(algT), args...;
            kwargs...
        ) where {T, V, P}
        sol, partials = nonlinearsolve_forwarddiff_solve(prob, alg, args...; kwargs...)
        dual_soln = nonlinearsolve_dual_solution(sol.u, partials, prob.p)
        return SciMLBase.build_solution(
            prob, alg, dual_soln, sol.resid;
            sol.retcode, sol.stats, sol.original,
            left = Dual{T, V, P}(sol.left, partials),
            right = Dual{T, V, P}(sol.right, partials)
        )
    end
end

# Handle the case where Duals are in tspan (bracket endpoints) rather than in p.
# This occurs in DiffEqBase callback root-finding where the integrator's time values
# are Dual numbers, but p is not passed to the IntervalNonlinearProblem.
#
# The derivative of the root w.r.t. the bracket position is zero (the root is where
# f=0, independent of bracket position). However, f's closure may capture Dual-valued
# state (e.g. from an ODE integrator differentiating w.r.t. parameters), making this
# a mixed case where dt*/dθ is nonzero via the implicit function theorem:
#   dt*/dθ = -(∂f/∂θ) / (∂f/∂t)
#
# We compute this by evaluating f at the root and a nearby offset point, then applying
# the secant formula in Dual arithmetic. The offset uses sqrt(ε) spacing so the secant
# slope is well-conditioned (unlike machine-precision brackets where rounding dominates).
# Using the same Dual tag T as the tspan avoids introducing a foreign tag that would
# conflict with the caller's type system (e.g. ODE interpolant buffers typed for T).

const DualTspanIntervalNonlinearProblem{
    T,
    V,
    P,
} = IntervalNonlinearProblem{
    iip, <:Tuple{Dual{T, V, P}, Dual{T, V, P}},
} where {iip}

for algT in (Bisection, Brent, Alefeld, Falsi, ITP, Ridder, ModAB)
    @eval function CommonSolve.solve(
            prob::DualTspanIntervalNonlinearProblem{T, V, P}, alg::$(algT), args...;
            kwargs...
        ) where {T, V, P}
        # Strip Duals from tspan and f returns for the solver
        tspan = (ForwardDiff.value(prob.tspan[1]), ForwardDiff.value(prob.tspan[2]))
        f_orig = prob.f
        f_stripped(t, p) = ForwardDiff.value(f_orig(t, p))
        newprob = IntervalNonlinearProblem{false}(f_stripped, tspan, prob.p; prob.kwargs...)
        sol = CommonSolve.solve(newprob, alg, args...; kwargs...)

        # Check if f's closure captures Dual-valued state (mixed case).
        # Both calls use Float64 time inputs, so they pass through ODE interpolants
        # without type conflicts. The Dual return comes from the closure's state.
        f_at_root = f_orig(sol.u, prob.p)

        if f_at_root isa Dual{T, V, P}
            # Mixed case: apply implicit function theorem via Dual secant step.
            # Evaluate f at the root (where f ≈ 0) and a nearby offset point
            # to get an accurate secant slope for df/dt.
            delta = sqrt(eps(V)) * max(one(V), abs(sol.u))
            t_hi = ForwardDiff.value(prob.tspan[2])
            t_lo = ForwardDiff.value(prob.tspan[1])
            if sol.u + delta ≤ t_hi
                t_other = sol.u + delta
            else
                t_other = sol.u - delta
            end
            f_at_other = f_orig(t_other, prob.p)

            zero_p = Partials{P, V}(ntuple(_ -> zero(V), Val(P)))
            a = Dual{T, V, P}(sol.u, zero_p)
            b = Dual{T, V, P}(t_other, zero_p)
            root_dual = a - f_at_root * (b - a) / (f_at_other - f_at_root)
            partials = ForwardDiff.partials(root_dual)
        else
            # Pure tspan-Dual case: derivative w.r.t. boundary is zero.
            partials = Partials{P, V}(ntuple(_ -> zero(V), Val(P)))
        end

        dual_u = Dual{T, V, P}(sol.u, partials)
        left = Dual{T, V, P}(sol.left, partials)
        right = Dual{T, V, P}(sol.right, partials)

        return SciMLBase.build_solution(
            prob, alg, dual_u, sol.resid;
            sol.retcode, sol.stats, sol.original,
            left = left, right = right
        )
    end
end

end

module BracketingNonlinearSolve

using ConcreteStructs: @concrete
using PrecompileTools: @compile_workload, @setup_workload
using Reexport: @reexport

using CommonSolve: CommonSolve, solve
using NonlinearSolveBase: NonlinearSolveBase, AbstractNonlinearSolveAlgorithm, NonlinearVerbosity, @SciMLMessage, AbstractVerbosityPreset
using SciMLBase: SciMLBase, IntervalNonlinearProblem, ReturnCode

abstract type AbstractBracketingAlgorithm <: AbstractNonlinearSolveAlgorithm end

include("utils.jl")
include("common.jl")

include("alefeld.jl")
include("bisection.jl")
include("brent.jl")
include("falsi.jl")
include("itp.jl")
include("muller.jl")
include("ridder.jl")
include("modAB.jl")

# Default Algorithm
function CommonSolve.solve(prob::IntervalNonlinearProblem; kwargs...)
    return CommonSolve.solve(prob, ModAB(); kwargs...)
end

function CommonSolve.solve(prob::IntervalNonlinearProblem, nothing, args...; kwargs...)
    return CommonSolve.solve(prob, ModAB(), args...; kwargs...)
end

function CommonSolve.solve(
        prob::IntervalNonlinearProblem,
        alg::AbstractBracketingAlgorithm, args...; sensealg = nothing, kwargs...
    )
    return bracketingnonlinear_solve_up(
        prob::IntervalNonlinearProblem, sensealg, prob.p, alg, args...; kwargs...
    )
end

function bracketingnonlinear_solve_up(
        prob::IntervalNonlinearProblem, sensealg, p, alg, args...; kwargs...
    )
    return SciMLBase.__solve(prob, alg, args...; kwargs...)
end

@setup_workload begin
    for T in (Float32, Float64)
        prob_brack = IntervalNonlinearProblem{false}(
            (u, p) -> u^2 - p, T.((0.0, 2.0)), T(2)
        )
        algs = (Alefeld(), Bisection(), Brent(), Falsi(), ITP(), Ridder())

        @compile_workload begin
            @sync for alg in algs
                Threads.@spawn CommonSolve.solve(prob_brack, alg; abstol = 1.0e-6)
            end
        end
    end
end

@reexport using SciMLBase, NonlinearSolveBase

export Alefeld, Bisection, Brent, Falsi, ITP, Muller, Ridder, ModAB

end

"""
    Ridder()

A non-allocating ridder method.
"""
struct Ridder <: AbstractBracketingAlgorithm end

function SciMLBase.__solve(
        prob::IntervalNonlinearProblem, alg::Ridder, args...;
        maxiters = 1000, abstol = nothing, verbose::NonlinearVerbosity = NonlinearVerbosity(), kwargs...
    )
    @assert !SciMLBase.isinplace(prob) "`Ridder` only supports out-of-place problems."

    f = Base.Fix2(prob.f, prob.p)
    left, right = prob.tspan
    fl, fr = f(left), f(right)

    abstol = NonlinearSolveBase.get_tolerance(
        left, abstol, promote_type(eltype(left), eltype(right))
    )

    if iszero(fl)
        return build_exact_solution(prob, alg, left, fl, ReturnCode.ExactSolutionLeft)
    end

    if iszero(fr)
        return build_exact_solution(prob, alg, right, fr, ReturnCode.ExactSolutionRight)
    end

    if sign(fl) == sign(fr)
        @SciMLMessage(
            "The interval is not an enclosing interval, opposite signs at the \
        boundaries are required.",
            verbose, :non_enclosing_interval
        )
        return build_bracketing_solution(prob, alg, left, fl, left, right, ReturnCode.InitialFailure)
    end

    i = 1
    while i ≤ maxiters
        mid = (left + right) / 2

        if mid == left || mid == right
            return build_bracketing_solution(prob, alg, left, fl, left, right, ReturnCode.FloatingPointLimit)
        end

        fm = f(mid)
        if iszero(fm)
            return build_exact_solution(prob, alg, mid, fm, ReturnCode.Success)
        end

        s = sqrt(fm^2 - fl * fr)
        if iszero(s)
            return build_bracketing_solution(prob, alg, left, fl, left, right, ReturnCode.Failure)
        end

        x = mid + (mid - left) * sign(fl - fm) * fm / s
        fx = f(x)
        if iszero(fx)
            return build_exact_solution(prob, alg, x, fx, ReturnCode.Success)
        end

        if abs((right - left) / 2) < abstol
            return build_bracketing_solution(prob, alg, mid, fm, left, right, ReturnCode.Success)
        end

        if sign(fx) != sign(fm)
            left = mid
            fl = fm
            right = x
            fr = fx
        elseif sign(fx) != sign(fl)
            right = x
            fr = fx
        else
            @assert sign(fx) != sign(fr)
            left = x
            fl = fx
        end

        i += 1
    end

    return build_bracketing_solution(prob, alg, left, fl, left, right, ReturnCode.MaxIters)
end

@testitem "Muller" begin
    f(u, p) = u^2 - p
    g(u, p) = sin(u)
    h(u, p) = exp(-u) * sin(u)
    i(u, p) = u^3 - 1

    @testset "Quadratic function" begin
        tspan = (10.0, 30.0)
        p = 612.0
        prob = IntervalNonlinearProblem{false}(f, tspan, p)
        sol = solve(prob, Muller())

        @test sol.u ≈ √612

        tspan = (-10.0, -30.0)
        prob = IntervalNonlinearProblem{false}(f, tspan, p)
        sol = solve(prob, Muller())

        @test sol.u ≈ -√612
    end

    @testset "Sine function" begin
        tspan = (1.0, 3.0)
        prob = IntervalNonlinearProblem{false}(g, tspan)
        sol = solve(prob, Muller())

        @test sol.u ≈ π

        tspan = (2.0, 6.0)
        prob = IntervalNonlinearProblem{false}(g, tspan)
        sol = solve(prob, Muller())

        @test sol.u ≈ 2 * π
    end

    @testset "Exponential-sine function" begin
        tspan = (-2.0, -4.0)
        prob = IntervalNonlinearProblem{false}(h, tspan)
        sol = solve(prob, Muller())

        @test sol.u ≈ -π

        tspan = (-3.0, 1.0)
        prob = IntervalNonlinearProblem{false}(h, tspan)
        sol = solve(prob, Muller())

        @test sol.u ≈ 0 atol = 1.0e-15

        tspan = (-1.0, 1.0)
        prob = IntervalNonlinearProblem{false}(h, tspan)
        sol = solve(prob, Muller())

        @test sol.u ≈ π
    end

    @testset "Complex roots" begin
        tspan = (-1.0, 1.0 * im)
        prob = IntervalNonlinearProblem{false}(i, tspan)
        sol = solve(prob, Muller())

        @test sol.u ≈ (-1 + √3 * im) / 2

        tspan = (-1.0, -1.0 * im)
        prob = IntervalNonlinearProblem{false}(i, tspan)
        sol = solve(prob, Muller())

        @test sol.u ≈ (-1 - √3 * im) / 2
    end

    @testset "Middle" begin
        tspan = (10.0, 30.0)
        p = 612.0
        prob = IntervalNonlinearProblem{false}(f, tspan, p)
        sol = solve(prob, Muller(20.0))

        @test sol.u ≈ √612

        tspan = (1.0, 3.0)
        prob = IntervalNonlinearProblem{false}(g, tspan)
        sol = solve(prob, Muller(2.0))

        @test sol.u ≈ π

        tspan = (-2.0, -4.0)
        prob = IntervalNonlinearProblem{false}(h, tspan)
        sol = solve(prob, Muller(-3.0))

        @test sol.u ≈ -π

        tspan = (-1.0, 1.0 * im)
        prob = IntervalNonlinearProblem{false}(i, tspan)
        sol = solve(prob, Muller(0.0))

        @test sol.u ≈ (-1 + √3 * im) / 2
    end
end
